/*
 *  __      _ .__  .__
 * /  \    / \(__) (__)  ____ ______  ____
 * \   \/\/  /|  | |  |_/ __ \\_  _ \/  _ \ 
 *  \       //   |/   |\  ___/ |  |\(  <_> )
 *   \__/\_/ \__ \\__ \ \___  >|__|  \____/ 
 *              \/   \/     \/ By BScrk
 * Copyright (C) 2008-2009 Luca Benevolo <wiiero@free.fr>
 *
 * Original game concept (Liero) : Joosa Riekkinen in 1998
 * Wiiero is Liero game clone developed for Wii platform.
 * Wiiero is also avaiable on PSP and PC (linux/Windows) platform.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef LANG_H
#define LANG_H
#include <SDL/SDL.h>

enum{
  /*Game labels */
  WIIERO_LANG_GAME_LOAD,
  WIIERO_LANG_WARNING_CONNECT,
  WIIERO_LANG_WARNING_INGAME,
  WIIERO_LANG_WARNING_NOGAME,
  WIIERO_LANG_WARNING_RESTART,
  WIIERO_LANG_WARNING_PRESSKEY,
  WIIERO_LANG_GAME_PAUSED,
  WIIERO_LANG_GAME_SUICIDE,
  WIIERO_LANG_GAME_KILLED,
  /* Main Menu */
  WIIERO_LANG_MENU_PLAY,
  WIIERO_LANG_MENU_OPTI,
  WIIERO_LANG_MENU_REST,
  WIIERO_LANG_MENU_LOAD,
  WIIERO_LANG_MENU_SAVE,
  WIIERO_LANG_MENU_HELP,
  WIIERO_LANG_MENU_INFO,
  WIIERO_LANG_MENU_RETU,
  WIIERO_LANG_MENU_EXIT,
  /* OPT labels */
  WIIERO_LANG_DMA,
  WIIERO_LANG_GOT,
  WIIERO_LANG_CTF,
  WIIERO_LANG_INFO_ON,
  WIIERO_LANG_INFO_OFF,
  WIIERO_LANG_OPT_DIRT,
  WIIERO_LANG_OPT_SAND,
  WIIERO_LANG_OPT_NIGHT,
  /* Option Menu Labels */
  WIIERO_LANG_OPT_MENU_GMODE,
  WIIERO_LANG_OPT_MENU_LIVES,
  WIIERO_LANG_OPT_MENU_FLAGS,
  WIIERO_LANG_OPT_MENU_COUNT,
  WIIERO_LANG_OPT_MENU_RLTIM,
  WIIERO_LANG_OPT_MENU_BONUS,
  WIIERO_LANG_OPT_MENU_BNAME,
  WIIERO_LANG_OPT_MENU_RESOL,
  WIIERO_LANG_OPT_MENU_REGEN,
  WIIERO_LANG_OPT_MENU_ROCKS,
  WIIERO_LANG_OPT_MENU_AMBIE,
  WIIERO_LANG_OPT_MENU_SHADO,
  WIIERO_LANG_OPT_MENU_P1NAM,
  WIIERO_LANG_OPT_MENU_P2NAM,
  WIIERO_LANG_OPT_MENU_XTRAW,
  WIIERO_LANG_OPT_MENU_RETUR,
  /* Weapon selection part */
  WIIERO_LANG_WSELECT_LABEL,
  WIIERO_LANG_WSELECT_KO,  
  WIIERO_LANG_WSELECT_OK,    
  /* Players name menu */
  WIIERO_LANG_PNAME_LABEL,
 /* Round score */
  WIIERO_LANG_SCORE,
  WIIERO_LANG_FRAGS,
  WIIERO_LANG_DEATH,
  WIIERO_LANG_SUICID,
  WIIERO_LANG_RATIO,
  WIIERO_LANG_LIFES,
  WIIERO_LANG_TIME,
  WIIERO_LANG_FLAGS,
  WIIERO_LANG_WIN,
  WIIERO_LANG_DRAW,
  /* Config Info */
  WIIERO_LANG_LOAD_OK,
  WIIERO_LANG_LOAD_KO,
  WIIERO_LANG_SAVE_OK,
  WIIERO_LANG_SAVE_KO,
  /* Exit*/
  WIIERO_LANG_GAME_THX,
  WIIERO_LANG_GAME_BYE,
  /* Weapon names */
  WIIERO_LANG_WEAPON_NAMES_FIRST_ID,
  WIIERO_LANG_WEAPON_HANDGUN = WIIERO_LANG_WEAPON_NAMES_FIRST_ID,
  WIIERO_LANG_WEAPON_UZI,
  WIIERO_LANG_WEAPON_CHAINGUN,
  WIIERO_LANG_WEAPON_SHOOTGUN,
  WIIERO_LANG_WEAPON_SUPER_SHOOTGUN,
  WIIERO_LANG_WEAPON_MINIGUN,
  WIIERO_LANG_WEAPON_CANNON,
  WIIERO_LANG_WEAPON_BAZOOKA,
  WIIERO_LANG_WEAPON_DOOMSDAY,
  WIIERO_LANG_WEAPON_WINCHESTER,
  WIIERO_LANG_WEAPON_LARPA,
  WIIERO_LANG_WEAPON_BOUNCY_LARPA,
  WIIERO_LANG_WEAPON_ZIMM,
  WIIERO_LANG_WEAPON_RIFLE,
  WIIERO_LANG_WEAPON_BLASTER,
  WIIERO_LANG_WEAPON_GAUSS_GUN,
  WIIERO_LANG_WEAPON_FLAMER,
  WIIERO_LANG_WEAPON_MINI_ROCKER,
  WIIERO_LANG_WEAPON_MISSILE,
  WIIERO_LANG_WEAPON_RB_RAMPAGE,
  WIIERO_LANG_WEAPON_HELLRAIDER,
  WIIERO_LANG_WEAPON_LASER,
  WIIERO_LANG_WEAPON_GRASSHAPPER,
  WIIERO_LANG_WEAPON_BOOBY_TRAP,
  WIIERO_LANG_WEAPON_MINE,
  WIIERO_LANG_WEAPON_BOUNCY_MINE,
  WIIERO_LANG_WEAPON_FLOAT_MINE,
  WIIERO_LANG_WEAPON_SPIKEBALLS,
  WIIERO_LANG_WEAPON_CRACKLER,
  WIIERO_LANG_WEAPON_GRENADE,
  WIIERO_LANG_WEAPON_CLUSTER_BOMB,
  WIIERO_LANG_WEAPON_MINI_NUKE,
  WIIERO_LANG_WEAPON_BIG_NUKE,
  WIIERO_LANG_WEAPON_CHIQUITA_BOMB,
  WIIERO_LANG_WEAPON_EXPLOSIVES,
  WIIERO_LANG_WEAPON_NAPALM,
  WIIERO_LANG_WEAPON_DIRTBALL,
  WIIERO_LANG_MAX_WEAPONS=WIIERO_LANG_WEAPON_DIRTBALL,
  WIIERO_LANG_WEAPON_HOLY_GRENADE,
  WIIERO_LANG_WEAPON_SUPER_CANNON,
  WIIERO_LANG_WEAPON_CEILING_MINE,
  WIIERO_LANG_WEAPON_GH_GRENADE,
  WIIERO_LANG_WEAPON_BLUE_FLAMER,
  WIIERO_LANG_WEAPON_AN_M14_GRENADE,
  WIIERO_LANG_WEAPON_GAZ_GRENADE,
  WIIERO_LANG_WEAPON_PLASMA_CANNON,
  WIIERO_LANG_WEAPON_NUKE_LARPA,
  WIIERO_LANG_WEAPON_CTRL_NUKE_LARPA,
  WIIERO_LANG_WEAPON_SC_LAUNCHER,
  WIIERO_LANG_WEAPON_VERMIFUGE,
  WIIERO_LANG_WEAPON_JUMPING_MINE,
  WIIERO_LANG_WEAPON_TRAP,
  WIIERO_LANG_WEAPON_KAMIKASE,
  WIIERO_LANG_WEAPON_SPIKE_TIME_BOMB,
  WIIERO_LANG_WEAPON_VIRAL_CASE, 
  WIIERO_LANG_WEAPON_VERMI_NUKE,
  WIIERO_LANG_WEAPON_MEDIKIT, 
  WIIERO_LANG_WEAPON_SHEELD,
  WIIERO_LANG_WEAPON_PINBALL,
  /* Controls labesl */
  WIIERO_LANG_CTRL_LABEL,
  WIIERO_LANG_CTRL_FIRST_ID = WIIERO_LANG_CTRL_LABEL,
  WIIERO_LANG_CTRL_FIRE,
  WIIERO_LANG_CTRL_JUMP,
  WIIERO_LANG_CTRL_DIG,
  WIIERO_LANG_CTRL_SWEAP,
  WIIERO_LANG_CTRL_PWEAP,
  WIIERO_LANG_CTRL_NWEAP,
  WIIERO_LANG_CTRL_NINJA,
  WIIERO_LANG_CTRL_UP,
  WIIERO_LANG_CTRL_DOWN,
  WIIERO_LANG_CTRL_LEFT,
  WIIERO_LANG_CTRL_RIGHT,
  WIIERO_LANG_CTRL_PAUSE,
  WIIERO_LANG_CTRL_MENU,
  WIIERO_LANG_CTRL_OK,
  WIIERO_LANG_CTRL_CANCEL,
  /* WIIERO V1.2 NEW LABELS */
  WIIERO_LANG_OPT_MENU_MUB,
  WIIERO_LANG_OPT_MENU_LANG,
  WIIERO_LANG_OPT_MENU_NEXT,
  WIIERO_LANG_OPT_MENU_PREV,
  WIIERO_LANG_NB_LABELS
};

extern char *wiiero_label[WIIERO_LANG_NB_LABELS];

#define MAX_LANGS 128
extern char *wiiero_lang_files[MAX_LANGS];
extern Uint8 get_nb_loaded_lang_files();
extern void check_lang_files();
extern void apply_lang(const char* filename);
#endif




